//+------------------------------------------------------------------+
//          Candle Alert                                             |
//+------------------------------------------------------------------+

#property copyright "Edas"
#property link      "edas@tdd.lt"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Green  
#property indicator_color2 Red

extern bool SoundON=true;
extern bool EmailON=false;

string SymbolsArray[10]={"GBPUSD","EURUSD","USDJPY","AUDUSD","USDCAD",
                         "USDCHF","EURGBP","EURJPY","GBPJPY","EURCAD"};
int timeframe[7] =     {    1,  5,      15,  30, 60, 240,1440};
double Range_factor[7]  = {10, 10,     3.5,   3, 2.5,   2, 2};
double Shadow_factor[7] = {10, 10,       8,   6,  5, 3.5, 3}; 
 
//string TF[7] = {"PERIOD_M1", "PERIOD_M5","PERIOD_M15","PERIOD_M30","PERIOD_H1","PERIOD_H4","PERIOD_D1"};
int distance[7] = {1,2,4,6,8,12,25};
//ideal is to scan all Symbols with for cycle
static int PrevSignal[10][6] = {0,0,0,0,0,0,0,0,0,0,  0,0,0,0,0,0,0,0,0,0,  
                                0,0,0,0,0,0,0,0,0,0,  0,0,0,0,0,0,0,0,0,0,  
                                0,0,0,0,0,0,0,0,0,0,  0,0,0,0,0,0,0,0,0,0};

static datetime PrevTime[10][6] =   {0,0,0,0,0,0,0,0,0,0,  0,0,0,0,0,0,0,0,0,0,  
                                0,0,0,0,0,0,0,0,0,0,  0,0,0,0,0,0,0,0,0,0,  
                                0,0,0,0,0,0,0,0,0,0,  0,0,0,0,0,0,0,0,0,0};
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators


//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 


//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   
   int counted_bars=IndicatorCounted();
   int  i, j, hour;
   
   
   string Message0, Message1, Message2;
   string Message_bull_engulf, Message_bear_engulf;
   string teststring = "testas";
   double High1, Low1, Range, OpCl, Ratio;
   double High2, Low2, Range2, OpCl2, Ratio2; 



   
   //timeframe[4] - hourly chart
   //planas suskirtyti i dvi dalis: 15-30 min didesni reikalavimai
   //                               60-240 min mazesni reikalavimai
   for (i = 0; i <= 9; i++) // symbol scan  
   {    for (j = 1; j <=5; j++) //timeframe scan  {1,5,15,30,60,240,1440}
        {

                    
         High1 =         iHigh(SymbolsArray[i], timeframe[j],1);
         Low1  =         iLow(SymbolsArray[i],  timeframe[j],1);
         Range =         iHigh(SymbolsArray[i], timeframe[j],1) - iLow(SymbolsArray[i], timeframe[j],1);  //one bar ago before current bar
         OpCl = MathAbs( iOpen(SymbolsArray[i], timeframe[j],1) - iClose(SymbolsArray[i], timeframe[j],1 )  );
         Ratio = Range/(OpCl+0.0001);
         
         High2 =         iHigh(SymbolsArray[i], timeframe[j],2);
         Low2  =         iLow(SymbolsArray[i],  timeframe[j],2);
         Range2 =         iHigh(SymbolsArray[i], timeframe[j],2) - iLow(SymbolsArray[i], timeframe[j],2);  //one bar ago before current bar
         OpCl2 = MathAbs( iOpen(SymbolsArray[i], timeframe[j],2) - iClose(SymbolsArray[i], timeframe[j],2 )  );
         Ratio2 = Range2/(OpCl2+0.0001);
         
         Message0 = "Candle Doji " + timeframe[j] + " min " + SymbolsArray[i] + 
         " TF " + timeframe[j] + " High " + DoubleToStr(High1,Digits) + 
         " Low " + DoubleToStr(Low1,Digits) + " RANGE " + DoubleToStr(Range*10000,0)  + " pips ";
         
         Message1 = "Candle Long Shadow " + timeframe[j] + " min " + SymbolsArray[i] + 
         " TF " + timeframe[j] + " High " + DoubleToStr(High1,Digits) + 
         " Low " + DoubleToStr(Low1,Digits) + " OpCl " + DoubleToStr(OpCl*10000,0) +
         " RANGE " + DoubleToStr(Range*10000,0)  + " pips RATIO " + DoubleToStr(Ratio,1);
         
         //small range after long range, 
         Message2 = "Candle Small Range " + SymbolsArray[i] + " TF " + timeframe[j] + 
         " min Range2 " + DoubleToStr(Range2*10000,0)  +  " Range1 " + DoubleToStr(Range*10000,0)+
         " pips Range RATIO " + DoubleToStr((Range2/Range),1);
         
         Message_bull_engulf = "Candle Bull Engulfing " + SymbolsArray[i] + " TF " + timeframe[j] + 
         " min OpCl2 " + DoubleToStr(OpCl2*10000,0)  +  " OpCl1 " + DoubleToStr(OpCl*10000,0)+
         " pips OC RATIO " + DoubleToStr((OpCl/OpCl2),1);
         
         Message_bear_engulf = "Candle Bear Engulfing " + SymbolsArray[i] + " TF " + timeframe[j] + 
         " min OpCl2 " + DoubleToStr(OpCl2*10000,0)  +  " OpCl " + DoubleToStr(OpCl*10000,0)+
         " pips OC_RATIO " + DoubleToStr((OpCl/OpCl2),1);

            // probably program does not understand this statement 
           if ( TimeCurrent() >= PrevTime[i][j] + 60* timeframe[j] ) //pause between the same symbol/timeframe alert
         {

  
         //long shadow, small body (last candle)
         if  ( Ratio >= Shadow_factor[j]) // {10, 10, 7, 5, 4,  3,   3}
            {
            Alert(Message1," TimePrevious ", TimeToStr(PrevTime[i][j]|TIME_SECONDS), " TimeCurrent ", TimeToStr(TimeCurrent()|TIME_SECONDS));
            Print(Message1);
            PrevTime[i][j] = TimeCurrent(); 
            Alert(Message1," TimePrevious ", TimeToStr(PrevTime[i][j]|TIME_SECONDS), " TimeCurrent ", TimeToStr(TimeCurrent()|TIME_SECONDS));
            }
         
         //bullish engulfing
   //       if((  Open[i+1]>Close[i+1]) && (Close[i+1]>Open[i])&& (Close[i]>Open[i+1]))
          if ( iOpen(SymbolsArray[i], timeframe[j],1+1) > iClose(SymbolsArray[i], timeframe[j],1+1) &&
               iClose(SymbolsArray[i], timeframe[j],1+1)> iOpen(SymbolsArray[i], timeframe[j],1) &&
               iClose(SymbolsArray[i], timeframe[j],1)  > iOpen(SymbolsArray[i], timeframe[j],1+1))
               {
               Alert(Message_bull_engulf);
               Print(Message_bull_engulf);
               PrevTime[i][j] = TimeCurrent(); 
               }
            
         //bearish engulfing
     //  if((    Close[i+1]>Open[i+1])&&(Open[i]>Close[i+1])&&(Open[i+1]>Close[i]))
         if (  iOpen(SymbolsArray[i], timeframe[j],1+1) < iClose(SymbolsArray[i], timeframe[j],1+1) &&
               iClose(SymbolsArray[i], timeframe[j],1+1) < iOpen(SymbolsArray[i], timeframe[j],1)   &&
               iClose(SymbolsArray[i], timeframe[j],1)   < iOpen(SymbolsArray[i], timeframe[j],1+1))
               {
               Alert(Message_bear_engulf);
               Print(Message_bear_engulf);
               PrevTime[i][j] = TimeCurrent(); 
               }
          
        }
        }
   }
   
   
   
   return(0);
}

